//--------------------------------------------------------------------//
// PUqV~[V

var canvas;			// LoXvf
var context;	 		// ReLXg
var pressed;			// }EX{^
var mx,my;			// }EXʒu
var theta0;			// px
var period;			// Uq̎
var len,gravity;		// UqEd͉x
var cx,cy,plen;			// UqS\ʒuE\
var motion;			// Uq^
var step=0,req=0;		// vZXebvEAj[ṼNGXgID

var N=120;			// px
var THETA=Math.PI*170.0/180.0;	// px̌x
var R=7;			// Uqd̕`攼a
var TOLE=1.0E-8;		// vZ臒l
var FONT_SIZE=14;		// tHgTCY
var BG_COLOR='rgb(0,0,0)';		// wiF
var FG_COLOR='rgb(255,255,255)';	// OiF

// Runge-Kutta-Gill@̌W1
var C1=[0.16666667,0.09763107,0.56903559,0.16666667];
// Runge-Kutta-Gill@̌W2
var C2=[[0.0],[0.5],[0.20710678,0.29289322],
      	[0.0,-0.70710678,1.70710678]];

// PUq
function initPendulum(){
  period=0;
  theta0=0;
  motion=new Motion();
  motion.initMotion();
  initCanvas();
  setDraw();
  draw();
}

// LoX
function initCanvas(){
  canvas=document.getElementById('motion');
  canvas.width=canvas.clientWidth;
  canvas.height=canvas.clientHeight;
  canvas.addEventListener('mousedown',mousePressed,false);
  canvas.addEventListener('mouseup',mouseReleased,false);
  canvas.addEventListener('mousemove',mouseMoved,false);
  context=canvas.getContext('2d');
  context.strokeStyle=FG_COLOR;
  context.font=FONT_SIZE+"px 'Arial'";
  pressed=false;
  mx=0;
  my=0;
  cx=canvas.width/2;
}

// }EX{^̏s
function mousePressed(e){
  pressed=true;
  mx=e.clientX;
  my=e.clientY;
  calcStop();
}

// }EX{^𗣂̏s
function mouseReleased(e){
  pressed=false;
}

// }EX{^ړ̏s
function mouseMoved(e){
  if(pressed){
    theta0+=Math.PI*(mx-e.clientX)/180;
    theta0=Math.min(Math.max(theta0,-THETA),THETA);
    motion.theta=theta0;
    mx=e.clientX;
    my=e.clientY;
    setDraw();
    draw();
  }
}

// Uq̎vZ
function calcPeriod(){
  period=4.0*Math.sqrt(len/gravity)*ellipseInt1(Math.sin(0.5*theta0));
}

// `̐ݒ
function setDraw(){
  cy=canvas.height/6;
  var maxWidth=canvas.height;
  if(theta0!==0){
    maxWidth=0.8*cx/Math.abs(Math.sin(theta0));
  }
  plen=Math.min(2.0*canvas.height/3.0,maxWidth);
  if(Math.abs(theta0)>0.5*Math.PI){
    var cc0=Math.cos(theta0);
    var dlen=plen*cc0/(cc0-1.0);
    cy+=dlen;
    plen-=dlen;
  }
}

// `悷
function draw(){
  context.fillStyle=BG_COLOR;
  context.fillRect(0,0,canvas.width,canvas.height);
  var px=cx-plen*Math.sin(motion.theta);
  var py=cy+plen*Math.cos(motion.theta);
  context.beginPath();
  context.moveTo(cx,cy);
  context.lineTo(px,py);
  context.closePath();
  context.stroke();
  context.fillStyle=FG_COLOR;
  context.beginPath();
  context.arc(px,py,R,0,2*Math.PI,false);
  context.closePath();
  context.fill();
  context.fillText(motion.info(),20,2*FONT_SIZE);
}

// [v֐
var step=0,req;
function loop(){
  step++;
  motion.nextStep();
  draw();
  req=requestAnimationFrame(loop);
}

// vZJn
function calcStart(){
  calcStop();
  len=document.getElementById('length').value;
  gravity=document.getElementById('gravity').value;
  calcPeriod();
  motion.dt=period/N;
  motion.cv=gravity*motion.dt/len;
  motion.initMotion();
  setDraw();
  loop();
}

// vZ~
function calcStop(){
  cancelAnimationFrame(req);
}

//  1 튮Sȉ~ϕԂ
function ellipseInt1(k){
  if(Math.abs(k)>=1) return 0;
  var a=1,b=Math.sqrt(1-k*k);
// ab̎Zp􉽕
  do{
    var a1=0.5*(a+b);
    var b1=Math.sqrt(a*b);
    a=a1;
    b=b1;
  }while(Math.abs(a-b)>TOLE*a);
  if(a===0) return 0;
  else      return 0.5*Math.PI/a;
}

//--------------------------------------------------------------------//
// Uq^
var Motion=function(){
  this.time=0;		// 
  this.theta=theta0;	// px
  this.w=0;		// px
  this.dt=0;		// ԑ
  this.cv=0;		// x
  this.dtha=[];		// f[^XVpz
  this.dwa=[];		// f[^XVpz
};

// ԁEpxEpx
Motion.prototype.initMotion=function(){
  this.time=0;
  this.theta=theta0;
  this.w=0;
};

// ̃^CXebvvZ
Motion.prototype.nextStep=function(){
  var dth=0.0;
  var dw=0.0;
  for(var i=0;i<4;i++){
    var sth=0.0;
    var sw=0.0;
    for(var j=0;j<i;j++){
      sth+=C2[i][j]*this.dtha[j];
      sw+=C2[i][j]*this.dwa[j];
    }
    this.dtha[i]=this.dt*(this.w+sw);
    this.dwa[i]=-this.cv*Math.sin(this.theta+sth);
    dth+=C1[i]*this.dtha[i];
    dw+=C1[i]*this.dwa[i];
  }
  this.time+=this.dt;
  this.theta+=dth;
  this.w+=dw;
};

// Uq^Ԃ
Motion.prototype.info=function(){
  var th=theta0*180.0/Math.PI;
  return 'period: '+period.toFixed(3)+'  time: '+this.time.toFixed(3)
      	+'  initial angle: '+th.toFixed(3)+'[deg]';
};
